#include <iostream>
#include <ctime>
#include <cmath> 
using namespace std;

class Point
{
private: int x;
		 int y;
public: Point (int x, int y);
		Point ();
		double distanceTo (Point p);
};

Point::Point()
{
	x = rand ();
	y = rand ();
}

Point::Point(int a, int b)
{
	x = a;
	y = b;
}

double Point::distanceTo(Point p)
{
	int num1, coordx, coordy, num2, num;
	double dist;
	num1 = x - p.x;
	coordx = num1*num1;
	num2 = y -p.y;
	coordy = num2*num2;
	num = coordx + coordy;
	dist = sqrt (1.0*num);
	return dist;
}

class Circle
{
private: double radius;
		 Point center;
public: Circle (Point p, double r);
		double area ();
		double perimeter ();
		bool contains (Circle b);
		bool intersects (Circle b);
};

Circle::Circle(Point z, double r)
{
	radius = r;
	center = z;
}
double Circle::area()
{
	return 3.14*radius*radius;
}
double Circle::perimeter()
{
	return 2*3.14*radius;
}
bool Circle :: intersects (Circle b)
{
	double r1, r2;
	Point ctr1;
	ctr1 = b.center;
	double distance;
	distance = ctr1.distanceTo(center);
	if (b.radius > radius)
	{
		r1 = radius;
		r2 = b.radius;
	}
	else
	{
		r1 = b.radius;
		r2 = radius;
	}
	if ( distance > (r1+r2))
		return false;
	else
	{
		if ( distance == (r1+r2))
			return true;
		else if ( distance == (r2-r1))
			return true;
		else if ( distance > (r2-r1))
			return true;
		else
			return false;
	}
}

bool Circle ::contains(Circle b)
{
	double r1, r2;
	Point ctr1;
	ctr1 = b.center;
	double distance;
	distance = ctr1.distanceTo(center);
	if (b.radius > radius)
	{
		r1 = radius;
		r2 = b.radius;
	}
	else
	{
		r1 = b.radius;
		r2 = radius;
	}
	if ((distance < (r1+r2) && (distance > (r2- r1))) || (distance > (r1+r2)) || (distance == r2+r1))
		return false;
	else
		return true;
}

	

void main ()
{
	Point a;
	Point b;
	cout << "The distance between the points is: " << b.distanceTo (a) << endl;
	Circle circ1 (a, 5);
	Circle circ2 (b, 6);
	cout << "the area of circle 1 is: " << circ1.area() << endl;
	cout << "the area of circle 2 is: " << circ2.area() << endl;
	cout << "the perm of circle 1 is: " << circ1.perimeter() << endl;
	cout << "the perm of circle 2 is: " << circ2.perimeter() << endl;
	if ( circ1.intersects(circ2) == true )
		cout << "The circles intersects" << endl;
	else
		cout << "They don't intersect" << endl;
	if ( circ1.contains(circ2) == true )
		cout << "The circles are contained" << endl;
	else
		cout << "They aren't contained" << endl;

}

